﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;
using System.Drawing.Text;

namespace howto_size_path_text
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Draw text samples.
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            const string txt = "Sample Text";

            int y = 10;
            e.Graphics.TextRenderingHint = TextRenderingHint.AntiAlias;
            e.Graphics.DrawString(txt, this.Font, Brushes.Green, 10, y);
            y += this.Font.Height;

            using (StringFormat string_format = new StringFormat())
            {
                string_format.Alignment = StringAlignment.Near;
                string_format.LineAlignment = StringAlignment.Near;

                // Get the form's font size in pixels no matter
                // what unit was used to create the font.
                float size_in_pixels = this.Font.SizeInPoints / 72 * e.Graphics.DpiX;

                using (GraphicsPath path = new GraphicsPath())
                {
                    path.AddString(txt, this.Font.FontFamily,
                        (int)this.Font.Style, size_in_pixels, new Point(10, y),
                        string_format);
                    e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;
                    e.Graphics.FillPath(Brushes.Green, path);
                }
            }
        }
    }
}
